<?php 
/*
Plugin Name: Query Multiple Taxonomies Shortcode 
Version: 0.5
Description: A shortcode for the Query Multiple Taxonomies Plugin developed by Cristi Burcă (scribu)
Author: ctlt
Author URI: http://ctlt.ubc.ca
Plugin URI: 
Text Domain: query-multiple-taxonomies-shortcode
Domain Path: /lang

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.
*/

add_shortcode( 'qmts', 'qmts_shortcode' );

// add_action('template_redirect', 'qmts_reset_url');
/**
 * qmts_shortcode function.
 * 
 * @access public
 * @param mixed $attr
 * @return void
 */
function qmts_shortcode( $attr ) {
	$queried_objects = get_queried_object();
	extract( shortcode_atts( array(
		'reset_url' 		=> site_url(),
		'taxonomies'		=> '',
		'type'				=> 'post',
		'before_label'		=> null,
		'labels'			=> null,
		'show_option_all' 	=> null,
		'submit'			=> null,
		'reset'				=> null
	), $attr ) );
	
	$include_taxonomies = explode( ",", $taxonomies );
	$labels_array = explode( ",", $labels);
	ob_start();	//we want to collect the output and return it instead of displaying it.
	
	if( is_object( $queried_objects ) ):
		foreach( $queried_objects as $item => $object  ):
			
			if($item == 'slug')
				$queried_object_slug = $object;
				
			if( $item == 'taxonomy')
				$queried_object_taxonomy = $object;
			
		endforeach;
	endif;
		?>
		<form class="taxonomy-drilldown-dropdowns" action="<?php echo site_url(); ?>" method="get" id="taxonomy-drilldown-dropdowns-form">
		<ul>
		<?php 
		$args = array(
	  		'public'   => true,
	  		'_builtin' => false
  		);
  		
		$taxs = get_taxonomies( $args ,'objects' ); 
		
		$cat = null;
		$show_all = $show_option_all;
		$count_labels = 0;
		foreach( $taxs as $tax_name => $tax ):
		
			if( in_array( $tax_name, $include_taxonomies ) ):
				$list_tax[] = $tax_name;
				if( $tax_name == $queried_object_taxonomy )
					$cat = $queried_object_slug;
				
				if( !empty( $_GET[$tax_name] ) )
					$cat = $_GET[$tax_name];
					
				if( !empty( $labels_array[$count_labels] ) ):
				  ?>
			<li><label><?php echo $labels_array[$count_labels]; ?></label>
				<?php
				else:
				 ?>
			<li><label><?php echo $tax->labels->name; ?>:</label>
				<?php
				endif;
				// fix this
				$show_option_all = ( is_null( $show_all ) ?  ( is_null( $before_label ) ? 'View all '.$tax->labels->name : $before_label.$tax->labels->name ) : $show_all );
				
				$dropdown_options = array(
					'show_option_all' 	=> __( $show_option_all ),
					'hide_empty' 		=> 0,
					'hierarchical' 		=> $tax->hierarchical,
					'show_count' 		=> 0,
					'taxonomy' 			=> $tax_name,
					'orderby' 			=> 'name',
					'selected' 			=> $cat,
					'name' 				=> $tax->name,
					'type'				=> $type
				);
				qmts_dropdown_categories( $dropdown_options );
				
				?></li>
				<?php
				// incoment the labels count 
				$count_labels++;
			endif;
		endforeach;
		$reset_url = ( substr($reset_url, 0, 4) == 'http' ? $reset_url : site_url( $reset_url ) );
		
		$submit = ( is_null( $submit ) ? 'Submit' : $submit );
		$reset = ( is_null( $reset ) ? 'Reset' : $reset );
		?>
		</ul>
		<input type="submit" value="<?php echo $submit; ?>">
		<a href="<?php echo $reset_url; ?>" class="taxonomy-drilldown-reset" id="taxonomy-drilldown-reset-link"><?php echo $reset; ?></a>
		<?php 
		/*
		 ?>
		<input type="hidden" name="reset_qmts" value="<?php echo esc_url( $reset_url ); ?>" />
		<input type="hidden" name="reset_qmts_taxonomies" value="<?php echo esc_attr( implode(",", $list_tax ) ); ?>" />
		<?php 
		/*
		*/ ?>
		</form>
		<script type="text/javascript">
		/*<![CDATA[*//*---->*/
		jQuery('#taxonomy-drilldown-dropdowns-form').submit(function(){
			// what should happen when you submit the form
			var submit_form = false;
			jQuery(this).find('select').each(function(){
				if( jQuery(this).val()  != "" ) {
					submit_form = true;
				}			
			});
			
			// reset the form the same way that the reset would work
			if( !submit_form ) {
				var url = jQuery('#taxonomy-drilldown-reset-link').attr('href');
				window.location=url;
				
			}
			return submit_form;
		});
		/*--*//*]]>*/
		</script>
		<?php
		$content = ob_get_contents();
		ob_end_clean();
		
		return $content;
}

function qmts_reset_url() {
	
	if( isset( $_GET['reset_qmts'] ) && isset( $_GET['reset_qmts_taxonomies'] ) && is_front_page() ):
		
		$redirect = true; // we will redirect unless there is accual content inside the stuff
		
		foreach( explode( ",", $_GET['reset_qmts_taxonomies'] ) as $taxonomy ):
			
			if( isset( $_GET[$taxonomy] ) && !empty( $_GET[$taxonomy] ) ):
				$redirect = false; 
			endif;
			
		endforeach;
		
		if( $redirect ):
			
			$url = ( substr($_GET['reset_qmts'], 0, 4) == 'http' ? $_GET['reset_qmts'] : site_url( $_GET['reset_qmts'] ) );
			
			wp_redirect( $url );
		endif;
		
	endif;

}

function qmts_dropdown_categories( $options ) {
	$args = array(
			'type'			=> $options['type'],
			'child_of'      => 0,
			'parent'        => '',
			'orderby'       => $options['orderby'],
			'order'         => 'ASC',
			'hide_empty'    => $options['hide_empty'],
			'hierarchical'  => $options['hierarchical'],
			'exclude'       => '',
			'include'       => '',
			'number'        => '',
			'taxonomy'      => $options["taxonomy"],
			'pad_counts'    => false
			);
	$terms  = get_categories( $args );
	// var_dump( $options['selected'] );
	echo "<select name='".$options["taxonomy"]."'>";
	
	echo "<option value=''>".$options['show_option_all']."</value>";
	$selected = "";
	foreach( $terms as $term ):
		
		if( $term->category_nicename == $options['selected'] )
			$selected = 'selected="selected"';
		
		echo "<option value='".$term->category_nicename."' ".$selected." >".$term->cat_name."</value>";
		$selected = '';
	endforeach;
	
	echo "</select>";
	
}


